Data class which stores the information of electrical circuit operation
示例#1
0
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="optionData">Data class object</param>
        public SelectCircuitForm(CircuitOperationData optionData)
        {
            m_optionData = optionData;

            InitializeComponent();
            InitializeElectricalSystems();
        }
示例#2
0
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="optionData">Data class object</param>
        public SelectCircuitForm(CircuitOperationData optionData)
        {
            m_optionData = optionData;

            InitializeComponent();
            InitializeElectricalSystems();
        }
示例#3
0
 /// <summary>
 /// Constructor
 /// </summary>
 /// <param name="optionData"></param>
 public CircuitOperationForm(CircuitOperationData optionData)
 {
     m_optionData = optionData;
     InitializeComponent();
     InitializeButtons();
     // Add tool tips
     AddToolTips();
 }
示例#4
0
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="data">Data class object</param>
        public EditCircuitForm(CircuitOperationData data)
        {
            m_data = data;

            InitializeComponent();
            // Add tool tips
            AddToolTips();
        }
示例#5
0
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="data">Data class object</param>
        public EditCircuitForm(CircuitOperationData data)
        {
            m_data = data;

            InitializeComponent();
            // Add tool tips
            AddToolTips();
        }
示例#6
0
 /// <summary>
 /// Constructor
 /// </summary>
 /// <param name="optionData"></param>
 public CircuitOperationForm(CircuitOperationData optionData)
 {
     m_optionData = optionData;
     InitializeComponent();
     InitializeButtons();
     // Add tool tips
     AddToolTips();
 }
示例#7
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData,
                                                ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            try
            {
                // Quit if active document is null
                if (null == commandData.Application.ActiveUIDocument.Document)
                {
                    message = Properties.Resources.ResourceManager.GetString("NullActiveDocument");
                    return(Autodesk.Revit.UI.Result.Failed);
                }

                // Quit if no elements selected
                if (commandData.Application.ActiveUIDocument.Selection.Elements.IsEmpty)
                {
                    message = Properties.Resources.ResourceManager.GetString("SelectPowerElements");
                    return(Autodesk.Revit.UI.Result.Failed);
                }

                // Collect information from selected elements and show operation dialog
                CircuitOperationData optionData = new CircuitOperationData(commandData);
                using (CircuitOperationForm mainForm = new CircuitOperationForm(optionData))
                {
                    if (mainForm.ShowDialog() == DialogResult.Cancel)
                    {
                        return(Autodesk.Revit.UI.Result.Cancelled);
                    }
                }

                // Show the dialog for user to select a circuit if more than one circuit available
                if (optionData.Operation != Operation.CreateCircuit &&
                    optionData.ElectricalSystemCount > 1)
                {
                    using (SelectCircuitForm selectForm = new SelectCircuitForm(optionData))
                    {
                        if (selectForm.ShowDialog() == DialogResult.Cancel)
                        {
                            return(Autodesk.Revit.UI.Result.Cancelled);
                        }
                    }
                }

                // If user choose to edit circuit, display the circuit editing dialog
                if (optionData.Operation == Operation.EditCircuit)
                {
                    using (EditCircuitForm editForm = new EditCircuitForm(optionData))
                    {
                        if (editForm.ShowDialog() == DialogResult.Cancel)
                        {
                            return(Autodesk.Revit.UI.Result.Cancelled);
                        }
                    }
                }

                // Perform the operation
                optionData.Operate();
            }
            catch (Exception ex)
            {
                message = ex.ToString();
                return(Autodesk.Revit.UI.Result.Failed);
            }

            return(Autodesk.Revit.UI.Result.Succeeded);
        }
示例#8
0
文件: Command.cs 项目: AMEE/revit
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application 
        /// which contains data related to the command, 
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application 
        /// which will be displayed if a failure or cancellation is returned by 
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application 
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command. 
        /// A result of Succeeded means that the API external method functioned as expected. 
        /// Cancelled can be used to signify that the user cancelled the external operation 
        /// at some point. Failure should be returned if the application is unable to proceed with 
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData,
        ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            try
            {
                // Quit if active document is null
                if (null == commandData.Application.ActiveUIDocument.Document)
                {
                    message = Properties.Resources.ResourceManager.GetString("NullActiveDocument");
                    return Autodesk.Revit.UI.Result.Failed;
                }

                // Quit if no elements selected
                if (commandData.Application.ActiveUIDocument.Selection.Elements.IsEmpty)
                {
                    message = Properties.Resources.ResourceManager.GetString("SelectPowerElements");
                    return Autodesk.Revit.UI.Result.Failed;
                }

                // Collect information from selected elements and show operation dialog
                CircuitOperationData optionData = new CircuitOperationData(commandData);
                using (CircuitOperationForm mainForm = new CircuitOperationForm(optionData))
                {
                    if (mainForm.ShowDialog() == DialogResult.Cancel)
                    {
                        return Autodesk.Revit.UI.Result.Cancelled;
                    }
                }

                // Show the dialog for user to select a circuit if more than one circuit available
                if (optionData.Operation != Operation.CreateCircuit &&
                    optionData.ElectricalSystemCount > 1)
                {
                    using (SelectCircuitForm selectForm = new SelectCircuitForm(optionData))
                    {
                        if (selectForm.ShowDialog() == DialogResult.Cancel)
                        {
                            return Autodesk.Revit.UI.Result.Cancelled;
                        }
                    }
                }

                // If user choose to edit circuit, display the circuit editing dialog
                if (optionData.Operation == Operation.EditCircuit)
                {
                    using (EditCircuitForm editForm = new EditCircuitForm(optionData))
                    {
                        if (editForm.ShowDialog() == DialogResult.Cancel)
                        {
                            return Autodesk.Revit.UI.Result.Cancelled;
                        }
                    }
                }

                // Perform the operation
                optionData.Operate();
            }
            catch (Exception ex)
            {
                message = ex.ToString();
                return Autodesk.Revit.UI.Result.Failed;
            }

            return Autodesk.Revit.UI.Result.Succeeded;
        }